# Obviously, this is an edited Boring Product that does chats.

__doc__ = """ZRTChat Product.  Real-time Chat for Zope."""

# Version string. Usually updated automatically by CVS. 

__version__ = '0.3.1' # I used to wonder whether Zope checked these. Nope. 

# Now, you can compress these imports down to three lines, but that makes it 
# harder to document it as you go. Here's the long-winded version: 

from Globals import HTMLFile      # fakes a method from a DTML file
from Globals import MessageDialog # 
from Globals import Persistent    # makes an object stick in the ZODB

import OFS.ObjectManager
import Acquisition
import AccessControl
import ZRTChatItem


"""Step #1: Provide "constructors" for Zope's management interface. 
__init__ is all very well and good for Python, but doesn't provide 
a nice HTML interface or accept arguments from an HTTP request, so 
you need to provide some functions to act as a middle-man between 
Zope and your class.

Use HTMLFile to produce a [pseudo-]function which hands back an 
appropriate DTML document based on a file sitting in your product 
directory. 
"""
manage_addZRTChatForm = HTMLFile('ZRTChatAdd', globals()) 

def manage_addZRTChat(self, id, REQUEST=None):
    """Add a ZRTChat to a folder."""
    self._setObject(id, ZRTChat(id))
    if REQUEST is not None:
        return self.manage_main(self, REQUEST)

class ZRTChat(
    OFS.ObjectManager.ObjectManager,   # An ObjectManager. Folderish. 
#    We already have the following from ObjectManager
    Persistent,            # Make us persistent. Yaah! 
    Acquisition.Implicit,  # Uh, whatever. 
    AccessControl.Role.RoleManager # Security manager. 
    ): 
    """ZRTChat folder."""
        
    meta_type = 'ZRTChat' # what did we do before meta_types?
    
    dontAllowCopyAndPaste = 1 #copying and pasting could be problems

    def all_meta_types(self):
       #need a doc string
        return ({'name':'ChatItem','action': 'ZRTChatItem.manage_addChatItem'},)

    manage_options = ( # what management options are there?
    {'label': 'Contents', 'action': 'manage_main'},
    
{'label':'Properties','action':'manage_workspace'},
{'label': 'View',       'action': 'index_html'}, # defaults to index_html
	{'label': 'Security',   'action': 'manage_access'},
        ) 

#   __ac_permissions__=( # what permissions make sense for us? 
#('View management screens', ('manage_tabs','manage_main')),
#3('Change permissions',      ('manage_access',)           ),
#	('Change ZRTChats'     ,     ('manage_edit',)             ),
#	('View ZRTChats',            ('',)                        ),
#	)

#the following is from OFS.ObjectManager; we will see if this default is OK
    __ac_permissions__= (
        ('View management screens', ('manage_workspace','manage_propertys','manage_main'),('Manager', 'Owner')),
        ('Access contents information',
         ('objectIds', 'objectValues', 'objectItems',''),
         ('Anonymous', 'Manager'),
         ),
        ('Delete objects',     ('manage_delObjects',),('Manager',),),

#'FTP access',         ('manage_FTPstat','manage_FTPlist')),
#       ('Import/Export objects',
#        ('manage_importObject','manage_importExportForm',
#         'manage_exportObject')
#        ),
    )

    def __init__(self, id): 
        """initialize a new instance of ZRTChat"""
        self.id = id
        self.topic = "Nice weather we are having..."
        self.returnlink = ''
        self.returntext = ''
        self.homelink = ''
        self.hometext = ''
        self.toptext = """First, identify yourself.  
Type your name at the bottom of 
the page and press "Submit name."
A new form will appear in the same window. 
Type your message in the text box
 and press "Post message." """
        self.bgcolor = '#ffffff'

    def title(self):
        #return the first few chars of the topic if requested for title
        if len(self.topic) > 40:
            return '%s ...' % self.topic[:40]
        else:
            return self.topic


    index_html = HTMLFile('index_html', globals()) # View Interface
    manage_main = HTMLFile('main',globals()) #management (view contents) interface

    chatframe = HTMLFile('chatframe', globals()) #the chat frame
    countform = HTMLFile('countform', globals())
    controls= HTMLFile('controls', globals())
    formframe= HTMLFile('formframe', globals())
    latestlastform= HTMLFile('latestlastform', globals())
    nfpost= HTMLFile('nfpost', globals())
    nfshowmsgs= HTMLFile('nfshowmsgs', globals())
    noframes= HTMLFile('noframes', globals())
    notablerowitem= HTMLFile('notablerowitem', globals())
    refreshform= HTMLFile('refreshform', globals())
    returnlinks= HTMLFile('returnlinks', globals())
    tablerowitem= HTMLFile('tablerowitem', globals())
    topframe= HTMLFile('topframe', globals())
        
    
    manage_propertys = HTMLFile('ZRTChatEdit', globals()) # Management Interface
    manage_workspace = manage_propertys

    def manage_edit(self, REQUEST=None): 
        """set the new properties"""
        if REQUEST is not None:
            self.topic = REQUEST.topic
            self.returnlink = REQUEST.returnlink
            self.returntext = REQUEST.returntext
            self.homelink = REQUEST.homelink
            self.hometext = REQUEST.hometext
            self.toptext = REQUEST.toptext
            self.bgcolor = REQUEST.bgcolor
            return MessageDialog(
	    	title = 'Edited',
		    message = "Properties for %s changed." % self.id,
		    action = './manage_properties',
		    )
    def addchatitem(self,REQUEST):
        #add a chat item
        ZRTChatItem.manage_addChatItem(self,REQUEST)
        
    
